import { Client } from "../mod.ts"

const query = Client().query.Media({ id: 1 }, (media) =>
  media
    .withId()
    .withIdMal()
    .withTitle((title) => title.userPreferred())
    .withType()
    .withFormat()
    .withStatus()
    .withDescription()
    .withStartDate((start) => start.withYear().withMonth().withDay())
    .withEndDate((end) => end.withYear().withMonth().withDay())
    .withSeason()
    .withSeasonYear()
    .withSeasonInt()
    .withEpisodes()
    .withDuration()
    .withChapters()
    .withVolumes()
    .withCountryOfOrigin()
    .withIsLicensed()
    .withSource()
    .withHashtag()
    .withTrailer((trailer) => trailer.withId())
    .withUpdatedAt()
    .withCoverImage((cover) => cover.withMedium())
    .withBannerImage()
    .withGenres()
    .withSynonyms()
    .withAverageScore()
    .withMeanScore()
    .withPopularity()
    .withIsLocked()
    .withTrending()
    .withFavourites()
    .withTags((tags) => tags.withId())
    .withRelations((relations) =>
      relations
        .withEdges((e) => e.withNode((n) => n.withId()))
        .withNodes((n) => n.withId())
        .withPageInfo((p) => p.withTotal())
    )
    .withCharacters(undefined, (character) =>
      character
        .withEdges((e) => e.withNode((n) => n.withId()))
        .withNodes((n) => n.withId())
        .withPageInfo((p) => p.withTotal()))
    .withStaff(undefined, (staff) =>
      staff
        .withEdges((e) => e.withNode((n) => n.withId()))
        .withNodes((n) => n.withId())
        .withPageInfo((p) => p.withTotal()))
    .withStudios(undefined, (studio) =>
      studio
        .withEdges((e) => e.withNode((n) => n.withId()))
        .withNodes((n) => n.withId())
        .withPageInfo((p) => p.withTotal()))
    .withIsFavourite()
    .withIsFavouriteBlocked()
    .withIsAdult()
    .withNextAiringEpisode((ep) => ep.withAiringAt())
    .withExternalLinks((links) => links.withId())
    .withStreamingEpisodes((ep) => ep.withSite())
    .withRankings((rank) => rank.withRank())
    .withMediaListEntry((entry) => entry.withId()))

console.log(await query.fetch())
