import type { CodegenConfig } from "@graphql-codegen/cli"

const config: CodegenConfig = {
  overwrite: true,
  schema: "https://graphql.anilist.co",
  verbose: true,
  debug: true,
  generates: {
    "../src/types/generated/graphql.ts": {
      plugins: ["typescript"],
      config: {
        useImplementingTypes: true,
        avoidOptionals: true,
        scalars: {
          CountryCode: {
            input: "string",
            output: "string",
          },
          FuzzyDateInt: {
            input: "string",
            output: "string",
          },
          Json: {
            input: "Array<Record<string, unknown>>",
            output: "Array<Record<string, unknown>>",
          },
        },
      },
    },
  },
}

export default config
