import { Fields, Fn, UpdateOperation } from "../types/Anilist.ts"
import { User } from "./User.ts"

export const AniChartUser = ({ query, level }: Fields<UpdateOperation>) => ({
  withUser(fn?: Fn<typeof User>) {
    query[0] = query[0].set({ subField: "user", level, hasSubField: true })
    let tmpQuery
    if (fn) fn(User({ query: tmpQuery = [query[0]], level: level + 1 }))
    else User({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withSettings() {
    query[0] = query[0].set({ subField: "settings", level })
    return this
  },
  withHighlights() {
    query[0] = query[0].set({ subField: "highlights", level })
    return this
  },
})
