import { Fields, UpdateOperation } from "../types/Anilist.ts"

export const ExternalLinkSourceCollection = ({ query, level }: Fields<UpdateOperation>) => ({
  /** The id of the external link */
  withId() {
    query[0] = query[0].set({ subField: "id", level })
    return this
  },
  /** The url of the external link or base url of link source */
  withUrl() {
    query[0] = query[0].set({ subField: "url", level })
    return this
  },
  /** The links website site name */
  withSite() {
    query[0] = query[0].set({ subField: "site", level })
    return this
  },
  /** The links website site id */
  withSiteId() {
    query[0] = query[0].set({ subField: "siteId", level })
    return this
  },
  withType() {
    query[0] = query[0].set({ subField: "type", level })
    return this
  },
  /** Language the site content is in. See Staff language field for values. */
  withLanguage() {
    query[0] = query[0].set({ subField: "language", level })
    return this
  },
  withColor() {
    query[0] = query[0].set({ subField: "color", level })
    return this
  },
  /** The icon image url of the site. Not available for all links. Transparent PNG 64x64 */
  withIcon() {
    query[0] = query[0].set({ subField: "icon", level })
    return this
  },
  withNotes() {
    query[0] = query[0].set({ subField: "notes", level })
    return this
  },
  withIsDisabled() {
    query[0] = query[0].set({ subField: "isDisabled", level })
    return this
  },
})
