import { Fields, Fn, UpdateOperation } from "../types/Anilist.ts"
import { ActivityReply } from "./ActivityReply.ts"
import { ListActivity, MessageActivity, TextActivity } from "./ActivityUnion.ts"
import { Thread } from "./Thread.ts"
import { ThreadComment } from "./ThreadComment.ts"

export const LikeableUnion = ({ query, level }: Fields<UpdateOperation>) => ({
  withListActivity(fn?: Fn<typeof ListActivity>) {
    query[0] = query[0].set({ subField: "ListActivity", level, hasSubField: true, isUnion: true })
    let tmpQuery
    if (fn) fn(ListActivity({ query: tmpQuery = [query[0]], level: level + 1 }))
    else ListActivity({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withTextActivity(fn?: Fn<typeof TextActivity>) {
    query[0] = query[0].set({ subField: "TextActivity", level, hasSubField: true, isUnion: true })
    let tmpQuery
    if (fn) fn(TextActivity({ query: tmpQuery = [query[0]], level: level + 1 }))
    else TextActivity({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withMessageActivity(fn?: Fn<typeof MessageActivity>) {
    query[0] = query[0].set({
      subField: "MessageActivity",
      level,
      hasSubField: true,
      isUnion: true,
    })
    let tmpQuery
    if (fn) fn(MessageActivity({ query: tmpQuery = [query[0]], level: level + 1 }))
    else MessageActivity({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withActivityReply(fn?: Fn<typeof ActivityReply>) {
    query[0] = query[0].set({ subField: "ActivityReply", level, hasSubField: true, isUnion: true })
    let tmpQuery
    if (fn) fn(ActivityReply({ query: tmpQuery = [query[0]], level: level + 1 }))
    else ActivityReply({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withThread(fn?: Fn<typeof Thread>) {
    query[0] = query[0].set({ subField: "Thread", level, hasSubField: true, isUnion: true })
    let tmpQuery
    if (fn) fn(Thread({ query: tmpQuery = [query[0]], level: level + 1 }))
    else Thread({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
  withThreadComment(fn?: Fn<typeof ThreadComment>) {
    query[0] = query[0].set({ subField: "ThreadComment", level, hasSubField: true, isUnion: true })
    let tmpQuery
    if (fn) fn(ThreadComment({ query: tmpQuery = [query[0]], level: level + 1 }))
    else ThreadComment({ query: tmpQuery = [query[0]], level: level + 1 }).withId()
    query[0] = tmpQuery[0]
    return this
  },
})
