import { Fields, UpdateOperation } from "../types/Anilist.ts"

export const MediaTag = ({ query, level }: Fields<UpdateOperation>) => ({
  /** The id of the tag */
  withId() {
    query[0] = query[0].set({ subField: "id", level })
    return this
  },
  /** The name of the tag */
  withName() {
    query[0] = query[0].set({ subField: "name", level })
    return this
  },
  /** A general description of the tag */
  withDescription() {
    query[0] = query[0].set({ subField: "description", level })
    return this
  },
  /** The categories of tags this tag belongs to */
  withCategory() {
    query[0] = query[0].set({ subField: "category", level })
    return this
  },
  /** The relevance ranking of the tag out of the 100 for this media */
  withRank() {
    query[0] = query[0].set({ subField: "rank", level })
    return this
  },
  /** If the tag could be a spoiler for any media */
  withIsGeneralSpoiler() {
    query[0] = query[0].set({ subField: "isGeneralSpoiler", level })
    return this
  },
  /** If the tag is a spoiler for this media */
  withIsMediaSpoiler() {
    query[0] = query[0].set({ subField: "isMediaSpoiler", level })
    return this
  },
  /** If the tag is only for adult 18+ media */
  withIsAdult() {
    query[0] = query[0].set({ subField: "isAdult", level })
    return this
  },
  /** The user who submitted the tag */
  withUserId() {
    query[0] = query[0].set({ subField: "userId", level })
    return this
  },
})
