import {
  SiteStatisticsAnimeArgs,
  SiteStatisticsCharactersArgs,
  SiteStatisticsMangaArgs,
  SiteStatisticsReviewsArgs,
  SiteStatisticsStaffArgs,
  SiteStatisticsStudiosArgs,
  SiteStatisticsUsersArgs,
} from "../types/generated/graphql.ts"
import { Fields, Fn, UpdateOperation } from "../types/Anilist.ts"
import type { AtLeastOne } from "../types/AtLeastOne.ts"
import { SiteTrendConnection } from "./SiteTrend.ts"

export const SiteStatistics = ({ query, level }: Fields<UpdateOperation>) => ({
  withUsers(
    op: { args?: AtLeastOne<SiteStatisticsUsersArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "users", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withAnime(
    op: { args?: AtLeastOne<SiteStatisticsAnimeArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "anime", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withManga(
    op: { args?: AtLeastOne<SiteStatisticsMangaArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "manga", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withCharacters(
    op: { args?: AtLeastOne<SiteStatisticsCharactersArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({
      subField: "characters",
      level,
      hasSubField: true,
      variables: op?.args,
    })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withStaff(
    op: { args?: AtLeastOne<SiteStatisticsStaffArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "staff", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withStudios(
    op: { args?: AtLeastOne<SiteStatisticsStudiosArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "studios", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withReviews(
    op: { args?: AtLeastOne<SiteStatisticsReviewsArgs>; fn: Fn<typeof SiteTrendConnection> },
  ) {
    query[0] = query[0].set({ subField: "reviews", level, hasSubField: true, variables: op?.args })
    let tmpQuery
    op.fn(SiteTrendConnection({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
})
