import { Fields, Fn, UpdateOperation } from "../types/Anilist.ts"
import { PageInfo } from "./Page.ts"

const SiteTrend = ({ query, level }: Fields<UpdateOperation>) => ({
  /** The day the data was recorded (timestamp) */
  withDate() {
    query[0] = query[0].set({ subField: "date", level })
    return this
  },

  withCount() {
    query[0] = query[0].set({ subField: "count", level })
    return this
  },
  /** The change from yesterday */
  withChange() {
    query[0] = query[0].set({ subField: "change", level })
    return this
  },
})

const SiteTrendEdge = ({ query, level }: Fields<UpdateOperation>) => ({
  withNode(fn: Fn<typeof SiteTrend>) {
    query[0] = query[0].set({ subField: "node", level, hasSubField: true })
    let tmpQuery
    fn(SiteTrend({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
})

export const SiteTrendConnection = ({ query, level }: Fields<UpdateOperation>) => ({
  withEdges(fn: Fn<typeof SiteTrendEdge>) {
    query[0] = query[0].set({ subField: "edges", level, hasSubField: true })
    let tmpQuery
    fn(SiteTrendEdge({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  withNodes(fn: Fn<typeof SiteTrend>) {
    query[0] = query[0].set({ subField: "nodes", level, hasSubField: true })
    let tmpQuery
    fn(SiteTrend({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
  /** The pagination information */
  withPageInfo(fn: Fn<typeof PageInfo>) {
    query[0] = query[0].set({ subField: "pageInfo", level, hasSubField: true })
    let tmpQuery
    fn(PageInfo({ query: tmpQuery = [query[0]], level: level + 1 }))
    query[0] = tmpQuery[0]
    return this
  },
})
